<template>
  <v-app class="serviceArchive">
    <div class="serviceArchive__subtitle">
      <h2>Нажмите для получения архива с услугами</h2>
    </div>

    <v-dialog v-model="dialog" max-width="500px">
      <template v-slot:activator="{ on, attrs }">
        <v-btn class="serviceArchive__btn" v-bind="attrs" v-on="on" style="margin-right: auto"
               @click="loadPageService">Создать
        </v-btn>
      </template>
      <v-card>
        <v-card-title>
          <span class="text-h5">{{ "Получить архив" }}</span>
        </v-card-title>

        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="12" sm="6" md="12">
                <v-select v-model="dialogItem.service" :items="services" item-value="id" item-text="name"
                          label="Услуга" multiple>
                  <v-list-item
                      ripple
                      @mousedown.prevent
                      @click="toggleService"
                  >
                    <v-list-item-action>
                      <v-icon :color="selectedService.length > 0 ? 'indigo darken-4' : ''">
                        {{ icon }}
                      </v-icon>
                    </v-list-item-action>
                  </v-list-item>
                </v-select>
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>

        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="#AFFFCF" @click="close">
            Закрыть
          </v-btn>
          <v-btn color="#AFFFCF" @click="requestReport">
            Получить архив
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-app>
</template>

<script>
import axios from "axios";

export default {
  name: "ServiceArchive",
  data() {
    return {
      dialog: false,
      services: [],
      servicesNames: [],
      selectedService: [],

      dialogItem: {
        service: '',
      },
    }
  },

  computed: {
    likesAllFruit() {
      return this.selectedService.length === this.services.length
    },
    likesSomeFruit() {
      return this.selectedService.length > 0 && !this.likesAllFruit
    },
    icon() {
      if (this.likesAllFruit) return 'mdi-close-box'
      if (this.likesSomeFruit) return 'mdi-minus-box'
      return 'mdi-checkbox-blank-outline'
    },
  },

  mounted() {
    this.fetchService()
  },

  methods: {
    async fetchService() {
      axios
          .get(this.$root.globalVar + '/service')
          .then(response => {
            this.serviceNames = response.data
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })
    },

    async fetchReport(item) {
      axios
          .post(this.$root.globalVar + '/archive/doctor/service', {
            ids: item.service
          }, {
            responseType: "blob"
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: недостаточно прав.')
          })
          .then(response => {
            console.log("Success", response);
            const blob = new Blob([response.data], {type: 'application/pdf'});
            console.log(blob)
            const objectUrl = URL.createObjectURL(blob);
            console.log(objectUrl);
            const downFile = document.createElement('a')
            downFile.href = objectUrl;
            downFile.download = 'service.zip';
            document.body.appendChild(downFile);
            downFile.click();
          })
    },

    toggleService() {
      this.$nextTick(() => {
        if (this.likesAllFruit) {
          this.selectedService = []
        } else {
          this.selectedService = this.services.slice()
        }
      })
    },

    loadPageService() {
      this.serviceNames.forEach(service => this.services.push(service))
    },

    close() {
      this.dialog = false
    },


    requestReport() {
      this.fetchReport(this.dialogItem)
      this.dialog = false
    }
  }
}
</script>

<style lang="scss" scoped>
.serviceArchive {
  &__subtitle {
    margin-bottom: 20px;
  }

  &__btn {
    margin: 0 auto;
  }
}
</style>